unit MPanel;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, dSGNiNtF, Buttons;

const TMPanelVersion='1.01';

type StType=(stExplode,stReach,stRoll,stShutDown);

TMPanelEditor = class ( TComponentEditor )
   function GetVerbCount: Integer; override;
   function GetVerb(Index: Integer): string; override;
   procedure ExecuteVerb(Index: Integer); override;
end;

type
  TMPanel = class(TPanel)
  private
    RollLine:Boolean;
    LineColor:TColor;
    RollText:Boolean;
    FBFS:Boolean;
    FActive:Boolean;
    Vreme:Longint;
    Pause:integer;
    fx,fy,sx,sy:integer;
    Sc:String;
    Pan:Tpanel;
    RandomE,
    ARefresh:boolean;
    STB,STE:STType;
    Fm_step:integer;
    FWidth,Fheight:Integer;
    SWidth,Sheight:Integer;
    FImage:TImage;
    { Private declarations }
    Procedure SetBFS(Value:boolean);
    Procedure SetFWidth(Value:Integer);
    Procedure SetFHeight(Value:Integer);
    Procedure SetSWidth(Value:Integer);
    Procedure SetSHeight(Value:Integer);
    Procedure Setm_step(Value:Integer);
    Procedure Info(Value:Boolean);
    Procedure SetSTB(Value:STType);
    Procedure SetSTE(Value:STType);
    Procedure SetAR(Value:Boolean);
    Procedure SetRE(Value:Boolean);
    Procedure SetSC(Value:String);
    Procedure SetImage(Bmp:TImage);
    Function  IsMIKS:Boolean;
    Procedure Ref;
  protected
    { Protected declarations }
    procedure MPMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure MPMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    Procedure StartTime;
    Function  InterVal:Longint;
    Procedure DblClick; OverRide;
  published
    { Published declarations }
    property M_FinalWidth:Integer read FWidth Write SetFWidth;
    property M_FinalHeight:Integer read Fheight Write SetFheight;
    property M_StartWidth:Integer read SWidth Write SetSWidth;
    property M_StartHeight:Integer read Sheight Write SetSheight;
    property M_Step:Integer read Fm_step Write Setm_step;
    property M_RollOn:sttype read stb Write SetSTb default stExplode;
    property M_RollOff:sttype read ste Write SetSTe default stExplode;
    property M_Registrated:Boolean read IsMIKS write Info;
    property M_AutoRefresh:Boolean read Arefresh write SetAR default False;
    Property M_RandomEffect:Boolean read RandomE write SetRE default false;
    Property M_StartCaption:string read SC write SetSC;
    Property M_StartTop: integer read SY write SY;
    Property M_StartLeft: integer read SX write SX;
    Property M_FinalTop: integer read FY write FY;
    Property M_FinalLeft: integer read FX write FX;
    property M_Delay:integer read Pause write Pause;
    Property M_Active:Boolean read FActive write FActive default True;
    Property M_StartFromStartPos:Boolean read FBFS write SetBFS default True;
    Property M_RollText:Boolean read RollText write RollText default True;
    Property M_RollLine:Boolean read RollLine write RollLine default True;
    Property M_LineColor:TColor read LineColor write LineColor default clWhite;
    property M_Image:TImage read FImage write SetImage;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MIKS', [TMPanel]);
  RegisterComponentEditor(TMPanel, TMPanelEditor);
end;


Function PTNF(w:integer; b:boolean):Integer;
{Positive True Negative False}
begin
  if b then begin if w<0 then w:=-w end
       else begin if w>0 then w:=-w end;
  PTNF:=w;
end;

Function Oko(sta,cega,koliko:LongInt):boolean;
begin
  oko:=(Sta>=Cega-koliko) and (sta<=cega+koliko)
end;

Function PosReach(var Value: integer; ReachTo, Step:integer):boolean;
begin
  if Oko(value,ReachTo,Step+1) then PosReach:=True else begin
    PosReach:=false;
    Value:=Value+PTNF(Step,Value<ReachTo);
  end;  
end;

Procedure TMPanel.SetImage;
begin
  FImage.Assign(Bmp);
  Invalidate;
end;


Procedure TMPanel.DblClick;
var w,oldtop,oldleft,i:integer; s,old:string;
begin
  if FActive then begin
    if m_Delay>0 then Arefresh:=True;
    If RandomE then Case Random(4) of
      0:stb:=stShutDown;
      1:stb:=stRoll;
      2:stb:=stExplode;
      3:stb:=stReach;
    end;
    if (Top<>FY) or (Left<>FX) then begin
      Caption:='';
      OldTop:=FY;
      OldLeft:=FX;

      w:=top;   while not PosReach (w,oldtop,m_step) do top:=w;
      w:=Left;  while not PosReach (W,oldLeft,m_step) do Left:=w;

      if m_step>0 then case stb of
        stShutDown:begin

          w:=Left;
          While Left<W+fWidth div 2- sWidth div 2 do
          begin
            Left:=Left+m_step;
            ref;
          end;

          w:=Top;
          While Top<W+fHeight div 2- sheight div 2 do begin
            Top:=Top+m_step;
            ref;
          end;

          while height>BevelWidth*2+2 do begin
            height:=height-m_step;
            ref;
          end;

          height:=BevelWidth*2+2;
          while (width<fwidth) or (left>oldleft)  do begin
            if left>oldleft then
              left:=left-PTNF(m_step,Left > OldLeft );
            if width<fwidth then
              width:=width+PTNF(m_step, fWidth>Width )*2;
            ref;
          end;

          while (top>oldtop) or (height<fheight) do begin
            if top>oldtop
              then top:=top-m_step;
            if height<fheight
              then height:=height+m_step* 2;
            ref
          end;

        end;
        stexplode:begin
          w:=oldtop+fHeight div 2-sheight div 2;
          while top<w do begin
            top:=top+m_step;
            ref
          end;
          w:=oldleft+fWidth div 2-swidth div 2;
          while left<w do begin
            left:=left+m_step;
            ref;
          end;
          While(top>OldTop) or (left>oldLeft) or
               (Width<fWidth) or (height<fHeight) do begin
            if top>oldtop then top:=top-PTNF(m_step,top > oldtop );
            if left>oldleft then left:=left-PTNF(m_step,left > OldLeft );
            if width<fwidth then width:=width+PTNF(m_step,width < fWidth )*2;
            if height<fheight then height:=height+PTNF(m_step,height<fHeight )*2;
            ref;
          end;
        end;
        stRoll:begin
          while top<>OldTop do begin
            top:=top+PTNF(m_step,top<OldTop );
            ref
          end;
          while left<>OldLeft do begin
            left:=left+PTNF(m_step,Left < Oldleft );
            ref;
          end;
          while (Width<fWidth) or (Height<fheight) do begin
            if Width<fWidth then Width:=width+PTNF(m_step,fWidth > Width );
            if height<fHeight then Height:=Height+PTNF(m_step,fHeight > Height );
            ref;
          end;
        end;
        stReach:begin
          while top<>OldTop do begin
            top:=top+PTNF(m_step,top<OldTop );
            ref
          end;
          while left<>OldLeft do begin
            left:=left+PTNF(m_step,Left < Oldleft );
            ref;
          end;
         while Width<m_finalWidth do begin
           Width:=width+PTNF(m_step,fwidth > width );
           ref;
         end;
         while Height<m_finalheight do begin
           Height:=Height+PTNF(m_step,fheight > height );
           ref;
         end;
       end;
      end;
      w:=top;   while not PosReach (w,Fy,m_step) do top:=w;
      w:=Left;  while not PosReach (W,FX,m_step) do Left:=w;
      w:=Height;while not PosReach (W,Fheight,m_step) do height:=w;
      w:=Width; while not PosReach (W,FWidth,m_step) do width:=w;

      if RollLine then With Canvas do begin
        Pen.Width:=2;
        For i:=0 to FWidth do begin
           Canvas.Pen.Color:=LineColor;
           MoveTo(i,0); LineTo(0,(Fheight * i div FWidth));
           if i>0 then begin
             Canvas.Pen.Color:=Color;
             MoveTo(i-1,0); LineTo(0,(Fheight * (i-1) div FWidth));
           end;
         end;
         With Canvas do For i:=0 to FWidth do begin
           Canvas.Pen.Color:=LineColor;
           MoveTo(i,Fheight);
           LineTo(FWidth,(Fheight * i div FWidth));
           if i>0 then begin
             Canvas.Pen.Color:=Color;
             MoveTo(i-1,Fheight);
             LineTo(FWidth,(Fheight * (i-1) div FWidth));
           end;
         end;
         Pen.Mode:=pmCopy;
         Pen.Width:=1;
      end;
      
      getdir(0,old);
      if not isMIKS then
        Canvas.TextOut(1,1,'Unregistrated version');

    end else if m_step>0 then begin
      OldTop:=SY;
      OldLeft:=SX;

      case StE of
       stShutDown:begin
         w:=Top;
         While (top<W+fHeight div 2+bevelWidth) or
               (height>BevelWidth*2+2) do begin
           if top<W+fHeight div 2+bevelWidth then
             Top:=Top+m_step;
           if height>BevelWidth*2+2 then Height:=Height-m_step*2;
           Ref;
         end;
         height:=BevelWidth*2+2;
         w:=Left;
         While (width>sWidth) or
               (left>W+fWidth div 2-sheight div 2) do begin
           if width>sWidth then Width:=Width-m_step * 2;
           if left<W+ fWidth div 2-sheight div 2
             then left:=left+m_step;
           Ref;
         end;
         While (height<sHeight) do begin
           Height:=Height+m_step *2;
           Top:=Top-m_step;
           Ref;
         end;
       end;
       stExplode:While (width>swidth) or (height>sheight) do begin
            if left<>oldleft+fwidth div 2 - swidth div 2
              then left:=left+PTNF(m_step,fWidth > sWidth );
            if width>swidth then width:=width-
              PTNF(m_step,m_startWidth<Width )*2;
            if top<>oldtop+Fheight div 2 - Sheight div 2
              then top:=top+PTNF(m_step,fy > sx );
            if height>sheight then
              height:=height-PTNF(m_step,SHeight < height )*2;
            ref;
          end;
       STRoll:while (width>SWidth) or (Height>Sheight) do begin
           if width<>SWidth then Width:=width-PTNF(m_step,Width>SWidth );
           if height<>SHeight then Height:=Height-PTNF(m_step,height>SHeight );
           ref;
         end;
       stReach:begin
         while width>SWidth do begin
           Width:=width-PTNF(m_step,Width>SWidth);
           ref;
         end;
         while Height>sheight do begin
           Height:=Height-PTNF(m_step,height>SHeight );
           ref;
         end;
       end;
      end;
      w:=top;   while not PosReach (w,Sy,m_step) do top:=w;
      w:=Left;  while not PosReach (W,Sx,m_step) do Left:=w;
      w:=Height;while not PosReach (W,Sheight,m_step) do height:=w;
      w:=Width; while not PosReach (W,SWidth,m_step) do width:=w;
      Caption:=SC;
    end;
  end;
  inherited DblClick;
end;

Function TMPanel.IsMIKS;
var old:String;
begin
  getdir(0,old);
  {$i-} chdir('c:\miks'); {$I+}
  IsMIKS:=ioresult=0;
  chdir(old);
end;

Procedure TMPanel.SetFWidth;
begin  if Value>Swidth then  FWidth:=value else fWidth:=SWidth+1; end;

Procedure TMPanel.SetFheight;
begin  if Value>Sheight then  Fheight:=Value else FHeight:=SHeight+1; end;

Procedure TMPanel.SetSWidth;
begin  if value<FWidth then  SWidth:=value else SWidth:=FWidth-1; end;

Procedure TMPanel.SetSheight;
begin if Value<Fheight then  Sheight:=Value else SHeight:=FHeight-1; end;

Procedure TMPanel.Setm_step;
begin Fm_step:=Value; end;

constructor TMPanel.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   vreme:=-1;
   Caption:= '>';
   FWidth:=100;
   Fheight:=100;
   SWidth:= 25;
   SHeight:= 25;
   Width:=SWidth;
   Height:=SHeight;
   Caption:=name+'>';
   m_startCaption:='>';
   m_step:=3;
   Font.Style:=[fsBOLD];
   BevelInner:=bvLowered;
   BorderStyle:=bsSingle;
   ParentColor:=True;
   ShowHint:=True;
   Hint:='Double click to roll on/off';
   ARefresh:=False;
   RandomE:=False;
   Randomize;
   m_startLeft:=Left;
   m_startTop:=Top;
   m_finalTop:=Top+Height;
   m_finalLeft:=Left+Width;
   FActive:=True;
   rolltext:=True;
   fbfs:=true;
   RollLine:=True;
   LineColor:=ClWhite;
end;

Procedure TMPanel.Info;
begin
  if not ismiks then Application.MessageBox
    ('TMPanel Roll On/Off panel version: '+
      TMPanelversion+#13+#10+
      'MIKS compan-y by Emir Kurtovic',
     'About', MB_OK or MB_ICONINFORMATION);
end;

Procedure TMPanel.SetSTB;
begin
  STB:=value;
end;

Procedure TMPanel.SetSC;
begin
  SC:=value;
  if FBFS then Caption:=SC;
end;

Procedure TMPanel.SetSTe;
begin
  STe:=value;
end;

Procedure TMPanel.SetAR;
begin
  ARefresh:=value;
end;

Procedure TMPanel.SetRE;
begin
  RandomE:=value;
end;

Procedure TMPanel.SetBFS;
begin
  FBFS:=value;
  if FBFS then begin
    Top:=SY;
    Left:=SX;
    Width:=SWidth;
    Height:=Sheight;
    Caption:=m_StartCaption;
  end;
end;

Procedure TMPanel.Ref;
begin
  If ARefresh then Refresh;
  If m_Delay>0 then begin
    StartTime;
    Repeat
      Application.ProcessMessages;
    Until Interval>m_Delay;
  end;  
end;

Procedure TMPanel.StartTime;
Var H,M,S:Word;
begin
  DecodeTime(Time,H,H,S,M);
  Vreme:=S*1000+M;
end;

Function  TMPanel.InterVal;
Var H,m,S:Word; l:Longint;
begin
  if vreme>0 then begin
    DecodeTime(Time,H,H,s,M);
    l:=s;
    l:=l*1000+m;
    l:=l-Vreme;
    if l<0
      then Interval:=m_Delay+1
      else InterVal:=L;
  end else interVal:=M_Delay+1;
end;

function TMPanelEditor.GetVerbCount: Integer;
begin
   Result := 11;
end;

function TMPanelEditor.GetVerb(Index: Integer): String;
begin
  case Index of
  0: Result := 'set to &Start coords';
  1: Result := 'set to &Final coords';
  2: Result := '&Begin from [Start] pos';
  3: Result := '-';
  4: Result := 'Go to s&tart';
  5: Result := 'Go to f&inal';
  6: Result := '-';
  7: Result := 'S&hutDown';
  8: Result := '&Explode';
  9: Result := '&Roll';
 10: Result := 'Rea&ch';
  end;
end;

procedure TMPanelEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
  0: begin
       with TMPanel(Component) do begin
         SetSWidth(Width);
         SetSHeight(Height);
         SY:=Top;
         SX:=Left;
         Width:=SWidth;
         height:=Sheight;
         SC:=Caption;
       end;
       Designer.Modified;
     end;
  1: begin
       With TMPanel(component) do begin
         SetFWidth(Width);
         setfheight(Height);
         fY:=Top;
         fX:=Left;
         Width:=fWidth;
         Height:=FHeight;
         Caption:='';
       end;
       Designer.Modified;
     end;
   2:begin
       TMPanel(component).SetBFS(True);
       Designer.Modified;
     end;
   3:;
   4:begin
      with TMPanel(component) do begin
        Width:=SWidth;
        height:=SHeight;
        Top:=SY;
        Left:=SX;
        Caption:=SC;
      end;
      Designer.Modified;
   end;
   5:begin
      with TMPanel(component) do begin
        Width:=FWidth;
        height:=FHeight;
        Top:=FY;
        Left:=FX;
        Caption:='';
      end;
      Designer.Modified;
   end;
   6:;
   7:begin
      TMPanel(component).STB:=stShutDown;
      TMPanel(component).STE:=stShutDown;
      Designer.Modified;
     end;
  8:begin
      TMPanel(component).STB:=stExplode;
      TMPanel(component).STE:=stExplode;
      Designer.Modified;
     end;
  9: begin
      TMPanel(component).STB:=stroll;
      TMPanel(component).STE:=stroll;
      Designer.Modified;
     end;
  10: begin
      TMPanel(component).STB:=stReach;
      TMPanel(component).STE:=streach;
      Designer.Modified;
     end;
  end;
end;

procedure TMPanel.MPMouseEnter(var Message: TMessage);
var s:String; k,j,i:integer;
begin
  s:=Caption;
  if s<>'' then if (Rolltext) then for k:=1 to 2 do for i:=1 to 3 do begin
    caption:='';
    for j:=1 to i do caption:=caption+' ';
    Caption:=caption+'>';
    StartTime;
    Refresh;
    Repeat Until Interval>50;
  end;
  if Width<FWidth
    then begin
       Caption:=s
    end else begin
      caption:='';
    end;
  Invalidate;
end;

procedure TMPanel.MPMouseLeave(var Message: TMessage);
begin
  Font.Color:=clBtnText;
  if Width<FWidth
    then Caption:=SC
    else Caption:='';
  Invalidate;
end;

destructor  TMpanel.Destroy;
begin
  fimage.Free;
  inherited destroy;
end;


end.

